#include <string.h>
#include <stdlib.h>
#include "internal.h"



static void* system_alloc(HAllocator *allocator, size_t size) {
  void *block = malloc(size);
  if (!block) {
    return NULL;
  }
  return block;
}

static void* system_realloc(HAllocator *allocator, void* uptr, size_t size) {
  if (!uptr) {
    return system_alloc(allocator, size);
  }
  // XXX this is incorrect if size == 0 and BLOCK_HEADER_SIZE != 0; it fails
  // to behave like free(3)
  void* block = realloc(uptr, size);
  if (!block) {
    return NULL;
  }
  return block;
}

static void system_free(HAllocator *allocator, void* uptr) {
  if (uptr) {
    free(uptr);
  }
}

HAllocator system_allocator = {
  .alloc = system_alloc,
  .realloc = system_realloc,
  .free = system_free,
};
